diff --git a/SHADE_Engine/src/Math/Vector/SHVec4.h b/SHADE_Engine/src/Math/Vector/SHVec4.h
index 911a714e..ce341bed 100644
--- a/SHADE_Engine/src/Math/Vector/SHVec4.h
+++ b/SHADE_Engine/src/Math/Vector/SHVec4.h
@@ -16,6 +16,7 @@
 
 // Project Headers
 #include "SH_API.h"
+#include "SHVec3.h"
 
 namespace SHADE
 {
@@ -53,6 +54,7 @@ namespace SHADE
     ~SHVec4 ()                  = default;
 
     SHVec4  ()                                    noexcept;
+    SHVec4  (const SHVec3& vec3)                  noexcept;
     SHVec4  (const XMFLOAT4& xmfloat4)            noexcept;
     SHVec4  (float x, float y, float z, float w)  noexcept;
 
@@ -102,16 +104,18 @@ namespace SHADE
     [[nodiscard]] float         Dot3D           (const SHVec4& rhs)                   const noexcept;
     [[nodiscard]] SHVec4        Cross3D         (const SHVec4& rhs)                   const noexcept;
     [[nodiscard]] SHVec4        Cross           (const SHVec4& v1, const SHVec4& v2)  const noexcept;
+
+    [[nodiscard]] SHVec3        ToVec3          ()                                    const noexcept;
   
     /*---------------------------------------------------------------------------------*/
     /* Static Function Members                                                         */
     /*---------------------------------------------------------------------------------*/
 
-    [[nodiscard]] static SHVec4 Normalise         (const SHVec4& v)                                                              noexcept;
-    [[nodiscard]] static SHVec4 Normalise3D       (const SHVec4& v)                                                              noexcept;
-    [[nodiscard]] static SHVec4 Abs               (const SHVec4& v)                                                              noexcept;
-    [[nodiscard]] static SHVec4 Min               (const std::initializer_list<SHVec4>& vs)                                      noexcept;
-    [[nodiscard]] static SHVec4 Max               (const std::initializer_list<SHVec4>& vs)                                      noexcept;
+    [[nodiscard]] static SHVec4 Normalise         (const SHVec4& v)                                                                 noexcept;
+    [[nodiscard]] static SHVec4 Normalise3D       (const SHVec4& v)                                                                 noexcept;
+    [[nodiscard]] static SHVec4 Abs               (const SHVec4& v)                                                                 noexcept;
+    [[nodiscard]] static SHVec4 Min               (const std::initializer_list<SHVec4>& vs)                                         noexcept;
+    [[nodiscard]] static SHVec4 Max               (const std::initializer_list<SHVec4>& vs)                                         noexcept;
     [[nodiscard]] static SHVec4 Clamp             (const SHVec4& v, const SHVec4& vMin, const SHVec4& vMax)                         noexcept;
     [[nodiscard]] static SHVec4 Lerp              (const SHVec4& a, const SHVec4& b, float t)                                       noexcept;
     [[nodiscard]] static SHVec4 ClampedLerp       (const SHVec4& a, const SHVec4& b, float t, float tMin = 0.0f, float tMax = 1.0f) noexcept;
diff --git a/SHADE_Engine/src/Physics/SHPhysicsObject.cpp b/SHADE_Engine/src/Physics/SHPhysicsObject.cpp
index 36f7c57e..f9b476ef 100644
--- a/SHADE_Engine/src/Physics/SHPhysicsObject.cpp
+++ b/SHADE_Engine/src/Physics/SHPhysicsObject.cpp
@@ -140,12 +140,12 @@ namespace SHADE
     isRigidBody  = true;
 
     rb->position    = tf->GetWorldPosition();
-    rb->orientation = tf->GetWorldRotation();
+    rb->orientation = SHQuaternion::FromEuler(tf->GetWorldRotation());
 
     if (hasColliders)
     {
       c->position    = tf->GetWorldPosition();
-      c->orientation = tf->GetWorldRotation();
+      c->orientation = SHQuaternion::FromEuler(tf->GetWorldRotation());
       // Get array of colliders and add them back into the rigidbody
       for (auto& collider : c->colliders | std::views::keys)
         AddCollider(&collider);
@@ -160,7 +160,7 @@ namespace SHADE
     hasColliders = true;
 
     c->position    = tf->GetWorldPosition();
-    c->orientation = tf->GetWorldRotation();
+    c->orientation = SHQuaternion::FromEuler(tf->GetWorldRotation());
 
     for (auto& collider : c->colliders | std::views::keys)
       AddCollider(&collider);
diff --git a/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp b/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp
index 7dc6c44e..a1994ad2 100644
--- a/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp
+++ b/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp
@@ -16,6 +16,7 @@
 // Project Headers
 #include "ECS_Base/Managers/SHComponentManager.h"
 #include "ECS_Base/Managers/SHEntityManager.h"
+#include "Math/SHMathHelpers.h"
 #include "Scene/SHSceneManager.h"
 #include "Math/Transform/SHTransformComponent.h"
 
@@ -315,7 +316,7 @@ namespace SHADE
       if (TF->HasChanged())
       {
         physicsObject.SetPosition(TF->GetWorldPosition());
-        physicsObject.SetRotation(TF->GetWorldRotation());
+        physicsObject.SetOrientation(TF->GetWorldOrientation());
       }
     }
   }
@@ -492,8 +493,7 @@ namespace SHADE
       // Convert RP3D Transform to SHADE
       auto* tfComponent = SHComponentManager::GetComponent<SHTransformComponent>(entityID);
       tfComponent->SetWorldPosition(rp3dPos);
-      tfComponent->SetWorldRotation(SHQuaternion{ rp3dRot }.ToEuler());
-
+      tfComponent->SetWorldOrientation(SHQuaternion{ rp3dRot });
 
       // Cache transforms
       physicsObject.prevTransform = CURRENT_TF;
diff --git a/SHADE_Engine/src/Resource/SHResourceManager.hpp b/SHADE_Engine/src/Resource/SHResourceManager.hpp
index 54ced715..cff4e84b 100644
--- a/SHADE_Engine/src/Resource/SHResourceManager.hpp
+++ b/SHADE_Engine/src/Resource/SHResourceManager.hpp
@@ -15,6 +15,7 @@ of DigiPen Institute of Technology is prohibited.
 #include "SHResourceManager.h"
 // Project Includes
 #include "Assets/SHAssetManager.h"
+#include "Assets/Asset Types/SHAssetIncludes.h"
 #include "Graphics/MiddleEnd/Interface/SHGraphicsSystem.h"
 #include "ECS_Base/Managers/SHSystemManager.h"
 #include "Tools/SHLog.h"
@@ -48,7 +49,7 @@ namespace SHADE
         throw std::runtime_error("[SHResourceManager] Attempted to load graphics resource without a SHGraphicsSystem installed.");
 
       // Load
-      const SHMeshAsset* assetData = SHAssetManager::GetMesh(assetId);
+      const SHMeshAsset* assetData = SHAssetManager::GetData<SHMeshAsset>(assetId);
       if (assetData == nullptr)
       {
         SHLog::Warning("[SHResourceManager] Attempted to load an asset with an invalid Asset ID.");
@@ -80,7 +81,7 @@ namespace SHADE
         throw std::runtime_error("[SHResourceManager] Attempted to load graphics resource without a SHGraphicsSystem installed.");
 
       // Load
-      const SHTextureAsset* assetData = SHAssetManager::GetTexture(assetId);
+      const SHTextureAsset* assetData = SHAssetManager::GetData<SHTextureAsset>(assetId);
       if (assetData == nullptr)
       {
         SHLog::Warning("[SHResourceManager] Attempted to load an asset with an invalid Asset ID.");
@@ -133,7 +134,7 @@ namespace SHADE
   /* Query Functions                                                                   */
   /*-----------------------------------------------------------------------------------*/
   template<typename T>
-  static std::optional<AssetID> SHResourceManager::GetAssetID(Handle<T> handle)
+  std::optional<AssetID> SHResourceManager::GetAssetID(Handle<T> handle)
   {
     const Handle GENERIC_HANDLE = Handle(handle);
     auto [typedHandleMap, typedAssetIdMap] = getAssetHandleMap<T>();
diff --git a/SHADE_Engine/src/Scene/SHSceneGraph.cpp b/SHADE_Engine/src/Scene/SHSceneGraph.cpp
index bbbdb7e4..950fd6a0 100644
--- a/SHADE_Engine/src/Scene/SHSceneGraph.cpp
+++ b/SHADE_Engine/src/Scene/SHSceneGraph.cpp
@@ -15,6 +15,7 @@
 
 // Project Headers
 #include "ECS_Base/Managers/SHEntityManager.h"
+#include "Events/SHEventManager.hpp"
 #include "Tools/SHLogger.h"
 #include "Tools/SHException.h"
 
@@ -317,6 +318,11 @@ namespace SHADE
     if (parentNode == nullptr)
     {
       SHLOG_WARNING("Removing Entity {}'s parent", entityID)
+
+      if (parent)
+        parent->RemoveChild(this);
+
+      return;
     }
 
     // Handle self assignment
@@ -359,10 +365,19 @@ namespace SHADE
     }
     ////////////////////////////////////////
 
+    const SHSceneGraphChangeParentEvent EVENT_DATA
+    {
+      .node       = NODE_ITER->second
+    , .oldParent  = NODE_ITER->second->GetParent()
+    , .newParent  = parent ? parent : root
+    };
+
     if (parent == nullptr)
       parent = root;
 
     NODE_ITER->second->SetParent(parent);
+
+    SHEventManager::BroadcastEvent<SHSceneGraphChangeParentEvent>(EVENT_DATA, SH_SCENEGRAPH_CHANGE_PARENT_EVENT);
   }
 
   void SHSceneGraph::SetParent(EntityID entityID, EntityID parent) const noexcept
@@ -396,8 +411,17 @@ namespace SHADE
     }
     ////////////////////////////////////////
 
+    const SHSceneGraphChangeParentEvent EVENT_DATA
+    {
+      .node       = NODE_ITER->second
+    , .oldParent  = NODE_ITER->second->GetParent()
+    , .newParent  = PARENT_ITER->second
+    };
+
     SHSceneNode* currentNode = NODE_ITER->second;
     currentNode->SetParent(PARENT_ITER->second);
+
+    SHEventManager::BroadcastEvent<SHSceneGraphChangeParentEvent>(EVENT_DATA, SH_SCENEGRAPH_CHANGE_PARENT_EVENT);
   }
 
   /*-----------------------------------------------------------------------------------*/
@@ -558,7 +582,7 @@ namespace SHADE
       ReleaseNode(node);
   }
 
-  void SHSceneGraph::Traverse (const UnaryPredicate& predicate) const
+  void SHSceneGraph::Traverse (const UnaryFunction& predicate) const
   {
     TraverseAndInvokePredicate(root, predicate);
   }
@@ -597,7 +621,7 @@ namespace SHADE
     delete node;
   }
 
-  void SHSceneGraph::TraverseAndInvokePredicate(const SHSceneNode* node, const UnaryPredicate& predicate)
+  void SHSceneGraph::TraverseAndInvokePredicate(const SHSceneNode* node, const UnaryFunction& predicate)
   {
     for (auto* child : node->children)
     { 
diff --git a/SHADE_Engine/src/Scene/SHSceneGraph.h b/SHADE_Engine/src/Scene/SHSceneGraph.h
index 3f3ebf92..a4cf45eb 100644
--- a/SHADE_Engine/src/Scene/SHSceneGraph.h
+++ b/SHADE_Engine/src/Scene/SHSceneGraph.h
@@ -97,9 +97,8 @@ namespace SHADE
     /* Type Definitions                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    using EntityNodeMap       = std::unordered_map<EntityID, SHSceneNode*>;
-
-    using UnaryPredicate      = std::function<void(SHSceneNode*)>;
+    using EntityNodeMap = std::unordered_map<EntityID, SHSceneNode*>;
+    using UnaryFunction = std::function<void(SHSceneNode*)>;
     
 
     /*---------------------------------------------------------------------------------*/
@@ -143,8 +142,7 @@ namespace SHADE
     bool          RemoveNode  (SHSceneNode* nodeToRemove)                         noexcept;
     void          Reset       ()                                                  noexcept;
 
-    void          Traverse    (const UnaryPredicate& predicate)                   const;
-    
+    void          Traverse    (const UnaryFunction& predicate)                    const;
 
   private:
     /*---------------------------------------------------------------------------------*/
@@ -160,8 +158,14 @@ namespace SHADE
 
     SHSceneNode*  AllocateNode                (EntityID entityID);
     void          ReleaseNode                 (SHSceneNode* node) noexcept;
-    static void   TraverseAndInvokePredicate  (const SHSceneNode* node, const UnaryPredicate& predicate);
+    static void   TraverseAndInvokePredicate  (const SHSceneNode* node, const UnaryFunction& predicate);
   };
 
+  struct SHSceneGraphChangeParentEvent
+  {
+    SHSceneNode* node;
+    SHSceneNode* oldParent;
+    SHSceneNode* newParent;
+  };
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Managed/src/Components/Transform.cxx b/SHADE_Managed/src/Components/Transform.cxx
index 0f0716dc..98f0da4f 100644
--- a/SHADE_Managed/src/Components/Transform.cxx
+++ b/SHADE_Managed/src/Components/Transform.cxx
@@ -29,13 +29,21 @@ namespace SHADE
     {
         GetNativeComponent()->SetLocalPosition(Convert::ToNative(val));
     }
-    Vector3 Transform::LocalRotation::get()
+    Quaternion Transform::LocalRotation::get()
     {
-        return Convert::ToCLI(GetNativeComponent()->GetLocalRotation());
+        return Convert::ToCLI(GetNativeComponent()->GetLocalOrientation());
     }
-    void Transform::LocalRotation::set(Vector3 val)
+    void Transform::LocalRotation::set(Quaternion val)
     {
-        GetNativeComponent()->SetLocalRotation(Convert::ToNative(val));
+        GetNativeComponent()->SetLocalOrientation(Convert::ToNative(val));
+    }
+    Vector3 Transform::LocalEulerAngles::get()
+    {
+      return Convert::ToCLI(GetNativeComponent()->GetLocalRotation());
+    }
+    void Transform::LocalEulerAngles::set(Vector3 val)
+    {
+      GetNativeComponent()->SetLocalRotation(Convert::ToNative(val));
     }
     Vector3 Transform::LocalScale::get()
     {
@@ -54,13 +62,21 @@ namespace SHADE
     {
         GetNativeComponent()->SetWorldPosition(Convert::ToNative(val));
     }
-    Vector3 Transform::GlobalRotation::get()
+    Quaternion Transform::GlobalRotation::get()
     {
-        return Convert::ToCLI(GetNativeComponent()->GetWorldRotation());
+        return Convert::ToCLI(GetNativeComponent()->GetLocalOrientation());
     }
-    void Transform::GlobalRotation::set(Vector3 val)
+    void Transform::GlobalRotation::set(Quaternion val)
     {
-        GetNativeComponent()->SetWorldRotation(Convert::ToNative(val));
+        GetNativeComponent()->SetWorldOrientation(Convert::ToNative(val));
+    }
+    Vector3 Transform::GlobalEulerAngles::get()
+    {
+      return Convert::ToCLI(GetNativeComponent()->GetWorldRotation());
+    }
+    void Transform::GlobalEulerAngles::set(Vector3 val)
+    {
+      GetNativeComponent()->SetWorldRotation(Convert::ToNative(val));
     }
     Vector3 Transform::GlobalScale::get()
     {
diff --git a/SHADE_Managed/src/Components/Transform.hxx b/SHADE_Managed/src/Components/Transform.hxx
index 9efd2927..bbe9fd19 100644
--- a/SHADE_Managed/src/Components/Transform.hxx
+++ b/SHADE_Managed/src/Components/Transform.hxx
@@ -17,14 +17,14 @@ of DigiPen Institute of Technology is prohibited.
 // Project Includes
 #include "Components/Component.hxx"
 #include "Math/Vector3.hxx"
-#include "Utility/Convert.hxx"
+#include "Math/Quaternion.hxx"
 // External Dependencies
 #include "Math/Transform/SHTransformComponent.h"
 
 namespace SHADE
 {
     /// <summary>
-    /// CLR version of the the SHADE Engine's TransformComponent.
+    /// CLR version of the SHADE Engine's TransformComponent.
     /// </summary>
     public ref class Transform : public Component<SHTransformComponent>
     {
@@ -52,9 +52,17 @@ namespace SHADE
             void set(Vector3 val);
         }
         /// <summary>
-        /// Local Z-axis rotation angle stored by this Transform in Radians.
+        /// Local rotation quaternion stored by this Transform.
         /// </summary>
-        property Vector3 LocalRotation
+        property Quaternion LocalRotation
+        {
+            Quaternion get();
+            void set(Quaternion val);
+        }
+        /// <summary>
+        /// Local euler angle rotations stored by this Transform.
+        /// </summary>
+        property Vector3 LocalEulerAngles
         {
             Vector3 get();
             void set(Vector3 val);
@@ -76,16 +84,23 @@ namespace SHADE
             void set(Vector3 val);
         }
         /// <summary>
-        /// Global Z-axis rotation angle stored by this Transform in Radians.
+        /// Global rotation quaternion stored by this Transform.
         /// </summary>
-        property Vector3 GlobalRotation
+        property Quaternion GlobalRotation
+        {
+            Quaternion get();
+            void set(Quaternion val);
+        }
+        /// <summary>
+        /// Global euler angle rotations stored by this Transform.
+        /// </summary>
+        property Vector3 GlobalEulerAngles
         {
             Vector3 get();
             void set(Vector3 val);
         }
         /// <summary>
         /// Global scale stored by this Transform.
-        /// Note that this operation is expensive.
         /// </summary>
         property Vector3 GlobalScale
         {
diff --git a/SHADE_Managed/src/Math/Math.cxx b/SHADE_Managed/src/Math/Math.cxx
index 5ec850a1..fa72e2b6 100644
--- a/SHADE_Managed/src/Math/Math.cxx
+++ b/SHADE_Managed/src/Math/Math.cxx
@@ -21,7 +21,7 @@ namespace SHADE
     /*---------------------------------------------------------------------------------*/
     /* Utility Functions                                                               */
     /*---------------------------------------------------------------------------------*/
-    double Math::Wrap(double value, double min, double max)
+    float Math::Wrap(float value, float min, float max)
     {
         while (value < min)
         {
@@ -33,24 +33,24 @@ namespace SHADE
         }
         return value;
     }
-    double Math::DegreesToRadians(double degrees)
+    float Math::DegreesToRadians(float degrees)
     {
         return degrees * Deg2Rad;
     }
-    double Math::RadiansToDegrees(double radians)
+    float Math::RadiansToDegrees(float radians)
     {
         return radians * Rad2Deg;
     }
-    double Math::Lerp(double a, double b, double t)
+    float Math::Lerp(float a, float b, float t)
     {
-        return LerpUnclamped(a, b, System::Math::Clamp(t, 0.0, 1.0));
+        return LerpUnclamped(a, b, System::Math::Clamp(t, 0.0f, 1.0f));
     }
-    double Math::LerpUnclamped(double a, double b, double t)
+    float Math::LerpUnclamped(float a, float b, float t)
     {
         return a + t * (b - a);
     }
 
-    double Math::InverseLerp(double a, double b, double value)
+    float Math::InverseLerp(float a, float b, float value)
     {
         return (value - a) / (b - a);
     }
diff --git a/SHADE_Managed/src/Math/Math.hxx b/SHADE_Managed/src/Math/Math.hxx
index 3ddc5149..1578d97c 100644
--- a/SHADE_Managed/src/Math/Math.hxx
+++ b/SHADE_Managed/src/Math/Math.hxx
@@ -27,11 +27,11 @@ namespace SHADE
         /// <summary>
         /// Degrees-to-radians conversion constant
         /// </summary>
-        static constexpr double Deg2Rad = System::Math::PI / 180.0;
+        static constexpr float Deg2Rad = System::Math::PI / 180.0f;
         /// <summary>
         /// Radians-to-degrees conversion constant
         /// </summary>
-        static constexpr double Rad2Deg = 180.0 / System::Math::PI;
+        static constexpr float Rad2Deg = 180.0f / System::Math::PI;
         /// <summary>
         /// Small value used for single precision floating point comparisons.
         /// </summary>
@@ -47,28 +47,28 @@ namespace SHADE
         /// <param name="min">Minimum value to wrap at.</param>
         /// <param name="max">Maximum value to wrap at.</param>
         /// <returns>Wrapped value.</returns>
-        static double Wrap(double value, double min, double max);
+        static float Wrap(float value, float min, float max);
         /// <summary>
         /// Converts an angle from degree representation to radian representation.
         /// </summary>
         /// <param name="degrees">Degree-based angle to convert.</param>
         /// <returns>The specified angle in radians.</returns>
-        static double DegreesToRadians(double degrees);
+        static float DegreesToRadians(float degrees);
         /// <summary>
         /// Converts an angle from radian representation to degree representation.
         /// </summary>
         /// <param name="radians">Radian-based angle to convert.</param>
         /// <returns>The specified angle in degrees.</returns>
-        static double RadiansToDegrees(double radians);
+        static float RadiansToDegrees(float radians);
         /// <summary>
         /// Linearly interpolates between a and b by t. 
         /// The parameter t is clamped to the range [0, 1].
         /// </summary>
         /// <param name="a">The start value.</param>
         /// <param name="b">The end value.</param>
-        /// <param name="t">The interpolation value between the two double.</param>
-        /// <returns>The interpolated double result between the two double values.</returns>
-        static double Lerp(double a, double b, double t);
+        /// <param name="t">The interpolation value between the two float.</param>
+        /// <returns>The interpolated float result between the two float values.</returns>
+        static float Lerp(float a, float b, float t);
         /// <summary>
         /// Linearly interpolates between a and b by t. 
         /// The parameter t is not clamped and a value based on a and b is supported. 
@@ -77,9 +77,9 @@ namespace SHADE
         /// </summary>
         /// <param name="a">The start value.</param>
         /// <param name="b">The end value.</param>
-        /// <param name="t">The interpolation value between the two double.</param>
-        /// <returns>The interpolated double result between the two double values.</returns>
-        static double LerpUnclamped(double a, double b, double t);
+        /// <param name="t">The interpolation value between the two float.</param>
+        /// <returns>The interpolated float result between the two float values.</returns>
+        static float LerpUnclamped(float a, float b, float t);
         /// <summary>
         /// Calculates the linear parameter t that produces the interpolant value within the range [a, b].
         /// </summary>
@@ -87,6 +87,6 @@ namespace SHADE
         /// <param name="b">End value.</param>
         /// <param name="value">Value between start and end.</param>
         /// <returns>Percentage of value between start and end.</returns>
-        static double InverseLerp(double a, double b, double value);
+        static float InverseLerp(float a, float b, float value);
     };
 }
diff --git a/SHADE_Managed/src/Math/Quaternion.cxx b/SHADE_Managed/src/Math/Quaternion.cxx
new file mode 100644
index 00000000..863241ac
--- /dev/null
+++ b/SHADE_Managed/src/Math/Quaternion.cxx
@@ -0,0 +1,170 @@
+/************************************************************************************//*!
+\file           Quaternion.cxx
+\author         Diren D Bharwani, diren.dbharwani, 390002520
+\par            email: diren.dbharwani\@digipen.edu
+\date           Oct 23, 2022
+\brief          Contains the definitions of functions in the Quaternion struct.
+ 
+                Note: This file is written in C++17/CLI.
+
+Copyright (C) 2021 DigiPen Institute of Technology.
+Reproduction or disclosure of this file or its contents without the prior written consent 
+of DigiPen Institute of Technology is prohibited.
+*//*************************************************************************************/
+
+// Precompiled Headers
+#include "SHpch.h"
+// Primary Header
+#include "Quaternion.hxx"
+// External Dependencies
+#include "Math/SHQuaternion.h"
+#include "Math/Vector/SHVec4.h"
+// Project Headers
+#include "Utility/Convert.hxx"
+#include "Math.hxx"
+
+namespace SHADE
+{
+  /*---------------------------------------------------------------------------------*/
+  /* Constructors                                                                    */
+  /*---------------------------------------------------------------------------------*/
+
+  Quaternion::Quaternion(float _x, float _y, float _z, float _w)
+  : x { _x }
+  , y { _y }
+  , z { _z }
+  , w { _w }
+  {}
+
+  /*---------------------------------------------------------------------------------*/
+  /* Usage Functions                                                                 */
+  /*---------------------------------------------------------------------------------*/
+
+  void Quaternion::SetFromToRotation(Vector3 fromDirection, Vector3 toDirection)
+  {
+    const SHQuaternion R = SHQuaternion::FromToRotation(Convert::ToNative(fromDirection), Convert::ToNative(toDirection));
+    *this = Convert::ToCLI(R);
+  }
+
+  void Quaternion::SetLookRotation(Vector3 view, Vector3 up)
+  {
+    const SHQuaternion R = SHQuaternion::LookRotation(Convert::ToNative(view), Convert::ToNative(up));
+    *this = Convert::ToCLI(R);
+  }
+
+  void Quaternion::ToAngleAxis(float^% angle, Vector3^% axis)
+  {
+    const SHVec4 NATIVE_AXIS_ANGLE = Convert::ToNative(*this).GetAxisAngle();
+    axis = Convert::ToCLI(NATIVE_AXIS_ANGLE.ToVec3());
+    angle = NATIVE_AXIS_ANGLE.w;
+  }
+
+  System::String^ Quaternion::ToString()
+  {
+    return ValueType::ToString();
+  }
+
+  /*---------------------------------------------------------------------------------*/
+  /* IEquatable                                                                      */
+  /*---------------------------------------------------------------------------------*/
+
+  bool Quaternion::Equals(Quaternion other)
+  {
+    const float DOT = Dot(*this, other);
+    return fabs(1.0f - DOT) <= Math::Epsilon;
+  }
+
+  /*---------------------------------------------------------------------------------*/
+  /* Object Overrides                                                                */
+  /*---------------------------------------------------------------------------------*/
+
+  bool Quaternion::Equals(Object^ o)
+  {
+    return ValueType::Equals(o);
+  }
+
+  int Quaternion::GetHashCode()
+  {
+    return ValueType::GetHashCode();
+  }
+
+  /*---------------------------------------------------------------------------------*/
+    /* Static Functions                                                                */
+    /*---------------------------------------------------------------------------------*/
+
+  float Quaternion::Angle(Quaternion a, Quaternion b)
+  {
+    return SHQuaternion::Angle(Convert::ToNative(a), Convert::ToNative(b));
+  }
+
+  Quaternion Quaternion::AngleAxis(float angle, Vector3 axis)
+  {
+    return Convert::ToCLI(SHQuaternion::FromAxisAngle(Convert::ToNative(axis), angle));
+  }
+
+  float Quaternion::Dot(Quaternion a, Quaternion b)
+  {
+    return (a.x * b.x) + (a.y * b.y) + (a.z * b.z) + (a.w * b.w);
+  }
+
+  Quaternion Quaternion::Euler(float _x, float _y, float _z)
+  {
+    return Convert::ToCLI(SHQuaternion::FromPitchYawRoll(_x, _y, _z));
+  }
+
+  Quaternion Quaternion::FromToRotation(Vector3 fromDirection, Vector3 toDirection)
+  {
+    return Convert::ToCLI(SHQuaternion::FromToRotation(Convert::ToNative(fromDirection), Convert::ToNative(toDirection)));
+  }
+
+  Quaternion Quaternion::Inverse(Quaternion rotation)
+  {
+    return Convert::ToCLI(SHQuaternion::Inverse(Convert::ToNative(rotation)));
+  }
+
+  Quaternion Quaternion::Lerp(Quaternion a, Quaternion b, float t)
+  {
+    return Convert::ToCLI(SHQuaternion::ClampedLerp(Convert::ToNative(a), Convert::ToNative(b), t));
+  }
+
+  Quaternion Quaternion::LerpUnclamped(Quaternion a, Quaternion b, float t)
+  {
+    return Convert::ToCLI(SHQuaternion::Lerp(Convert::ToNative(a), Convert::ToNative(b), t));
+  }
+
+  Quaternion Quaternion::LookRotation(Vector3 forward, Vector3 upwards)
+  {
+    return Convert::ToCLI(SHQuaternion::LookRotation(Convert::ToNative(forward), Convert::ToNative(upwards)));
+  }
+
+  Quaternion Quaternion::Normalize(Quaternion q)
+  {
+    return Convert::ToCLI(SHQuaternion::Normalise(Convert::ToNative(q)));
+  }
+
+  Quaternion Quaternion::RotateTowards(Quaternion from, Quaternion to, float maxDegreesDelta)
+  {
+    return Convert::ToCLI(SHQuaternion::RotateTowards(Convert::ToNative(from), Convert::ToNative(to), Math::DegreesToRadians(maxDegreesDelta)));
+  }
+
+  Quaternion Quaternion::Slerp(Quaternion a, Quaternion b, float t)
+  {
+    return Convert::ToCLI(SHQuaternion::ClampedSlerp(Convert::ToNative(a), Convert::ToNative(b), t));
+  }
+
+  Quaternion Quaternion::SlerpUnclamped(Quaternion a, Quaternion b, float t)
+  {
+    return Convert::ToCLI(SHQuaternion::Slerp(Convert::ToNative(a), Convert::ToNative(b), t));
+  }
+
+
+  Quaternion Quaternion::operator*(Quaternion lhs, Quaternion rhs)
+  {
+    return Convert::ToCLI(Convert::ToNative(lhs) * Convert::ToNative(rhs));
+  }
+
+  bool Quaternion::operator==(Quaternion lhs, Quaternion rhs)
+  {
+    return lhs.Equals(rhs);
+  }
+}
\ No newline at end of file
